/*
 * The reverse of "encode.c".
 */

#include <stdio.h>
#include <string.h>

#define LETTERS		('z' - 'a' + 1)
#define LCASE(c)	((c) | ('a' ^ 'A'))

void	Init (char* key);

int	main (int argc, char* argv[])
{
	char*	key;
	int	len, c, n;

	if (argc != 2) {
		fprintf (stderr, "Usage:  decode KEY < input > output\n");
		return 1;
	}

	Init (key = *++argv);
	len = strlen (key);

	for (n = 0; (c = getchar ()) != EOF; n = (n + 1) % len) {

		if ((c < 'a' || c > 'z') &&
		    (c < 'A' || c > 'Z')) {
			putchar (c);
			continue;
		}

		putchar ((LCASE (c | ('a' ^ 'A')) - key[n] + LETTERS) % LETTERS + 'A');
	}

	return 0;
}

void	Init (char* key)
{
	char*	to = key;

	// convert the key to uppercase letters only

	do
		if (*key >= 'a' && *key <= 'z' ||
		    *key >= 'A' && *key <= 'Z')
			*to++ = LCASE (*key);
	while (*key++);
}
